;------------   Exemple d'application avec un PIC : Un clignotant    ---------------
; Titre : Clignotant
; Date : 01 OCTOBRE 2004
; Auteur : P.M
; PIC utilis : PIC 16 F 84
; On ralise un clignotant sur la broche RB0  d' un PIC 16 F 84 le quartz est de 4 
; Mhz , on effectue une temporisation environ gale  0.2 seconde. 

;------------   Directive d' assemblage pour MPLAB   ---------------
 list p=16f84A            ;on indique ici le type de PIC utilis
 #include p16f84A.inc     ;c'est le fichier qui contient la liste des adresses des registres internes
 __config H'3FF9'		  ;configuration des fusibles 

;------------   Dfinition des constantes   ---------------
#define inter0 0          ; dclaration du bouton marche

;------------   Dfinition des registres temporaires   ---------------
retard1      EQU        0x0C      ; le registre temporaire retard1 se trouve  l' adresse 0C
retard2      EQU        0x0F      ; le registre temporaire retard2 se trouve  l' adresse 0F

;------------   Init des ports A et B   ---------------
          ORG     0               ; notre programme commencera  l'adresse 0 en mmoire      
          BSF STATUS,5            ; on met  1 le 5eme bit du registre status pour accder
                                  ;  la 2eme page mmoire ( pour trisa et trisb )
          MOVLW 0x00              ; on met 00 dans le registre W
          MOVWF TRISB             ; on met 00 dans TRISB le port B est programm en sortie
          MOVLW 0x1F              ; on met 1F dans le registre W
          MOVWF TRISA             ; on met 1F dans TRISA le port A est programm en entre
          BCF STATUS,5            ; on remet  0 le 5eme bit du registre status pour accder 
                                  ;  la 1eme page mmoire 

;------------   raz de la led et du PORTB  ---------------
         CLRF  PORTB                   ; RAZ du port B ( on teint la led )

;------------   Programme principal   ---------------

debut 
          btfss PORTA,inter0     ; interrupteur 0 ( marche ) appuy ? si oui on continu sinon 
          goto debut             ; on retourne  l'tiquette debut      
          COMF PORTB,F           ; On effectue le complment du PORTB
          MOVLW 0xFF             ; On charge le registre w avec la valeur FF (255)
          MOVWF retard1          ; On copie le contenu de w (FF) dans le registre retard1
          MOVWF retard2          ; On copie le contenu de w (FF) dans le registre retard2
          CALL  tempo            ; on appel la temporisation
          GOTO  debut            ; retour au dbut du programme

;------------   Programme de temporisation    ---------------
tempo
          DECFSZ retard1,F       ; on dcrmente retard1 et on saute la prochaine instruction si 
          GOTO  tempo            ; le registre retard1 = 0 sinon retour  tempo
          movlw 0xFF             ; on recharge retard1
          movwf retard1
          DECFSZ retard2,F       ; on dcrmente retard2 et on saute la prochaine instruction si 
          GOTO  tempo            ; le registre retard2 = 0 sinon retour  temp      
          RETURN                 ; retour au programme principal aprs l 'instruction CAL
          END


 








